<template>
  <div class="custom-select-dropdown">
    <b-dropdown ref="cDropdown" text="" variant="link" no-caret class="w-100" :disabled="disabled">
      <template #button-content class="btn-outline">
        <span class="ml-50 text-body float-left font-700">
          <span v-if="selectedItemTitle != ''">{{ selectedItemTitle }}</span>
          <span v-if="selectedItemTitle == ''">{{ selectTitle }}</span>
        </span>
        <b-img :src="downArrowIcon" class="text-body float-right" />
      </template>
      <b-dropdown-form>
        <div class="form-card" v-if="searchBar">
          <b-form-input v-model="searchItems" value="" @input="searchItemFromList($event)" placeholder="Search"
            type="text" class="d-inline-block custom-search-box" />
          <hr />
        </div>
        <template v-if="!isSearch" v-for="optionArr in options">
          <template v-if="optionArr.value.length > 0">
            <div class="form-card partition-name-title">
              {{ optionArr.name }}
            </div>
            <template v-for="option in optionArr.value">
              <b-form-checkbox v-model="checkedItems" :name="'custom-checkall-checkbox-' + selectTitle" :checked="true"
                :value="option.id" @change="checkRow()" inline v-if="isCheckbox" :disabled="checkItemDisabled(option.id)">
                {{ option.name }}
              </b-form-checkbox>
              <p v-if="!isCheckbox" class="select-option" :class="selectedValue == option.name || selectedValue == option.id
                  ? 'active'
                  : ''
                " @click="filterApply(option, true)">
                {{ option.name }}
                <span v-if="option.sidebarColor" class="sidebar-fill"
                  :style="{ 'background-color': option.sidebarColor }"></span>
              </p>
            </template>
            <div class="form-card">
              <hr />
            </div>
          </template>
        </template>
        <template v-if="isSearch" v-for="optionArr in optionsList">
          <template v-if="optionArr.value.length > 0">
            <div class="form-card partition-name-title">
              {{ optionArr.name }}
            </div>
            <template v-for="option in optionArr.value">
              <b-form-checkbox v-model="checkedItems" :name="'custom-checkall-checkbox-' + selectTitle" :checked="true"
                :value="option.id" @change="checkRow()" inline v-if="isCheckbox" :disabled="checkItemDisabled(option.id)">
                {{ option.name }}
              </b-form-checkbox>
              <p v-if="!isCheckbox" class="select-option" :class="selectedValue == option.name || selectedValue == option.id
                  ? 'active'
                  : ''
                " @click="filterApply(option, true)">
                {{ option.name }}
                <span v-if="option.sidebarColor" class="sidebar-fill"
                  :style="{ 'background-color': option.sidebarColor }"></span>
              </p>
            </template>
            <div class="form-card">
              <hr />
            </div>
          </template>
        </template>
        <template v-if="!isSearch && options.length == 0">
          <p class="select-option">
            No Items are available
          </p>
        </template>
        <template v-if="isSearch && optionsList.length == 0">
          <p class="select-option">
            No Items are available
          </p>
        </template>
        <b-form-checkbox v-if="isCustomeCheckbox" :checked="isCheckboxChecked" @change="customAction($event)" inline :disabled="itemDisabled == true && isCheckboxChecked == false ? true : false">
          {{ customeCheckboxTitle }}
        </b-form-checkbox>
      </b-dropdown-form>
    </b-dropdown>
  </div>
</template>

<script>
import {
  BButton,
  BFormGroup,
  BFormInput,
  BFormCheckboxGroup,
  BFormCheckbox,
  BImg,
  BCol,
  BRow,
  BCard,
  BDropdown,
  BDropdownItem,
  BDropdownForm,
} from "bootstrap-vue";
export default {
  components: {
    BCard,
    BButton,
    BCol,
    BRow,
    BImg,
    BFormInput,
    BFormCheckbox,
    BFormGroup,
    BFormCheckboxGroup,
    BDropdown,
    BDropdownItem,
    BDropdownForm,
  },
  props: {
    title: {
      type: String,
      require: false,
      default: "",
    },
    selectTitle: {
      type: String,
      require: false,
      default: "",
    },
    checkboxName: {
      type: String,
      require: false,
      default: "",
    },
    options: {
      type: Array,
      require: true,
    },
    selectedItemsArr: {
      type: Array,
      require: false,
      default: () => [],
    },
    searchBar: {
      type: Boolean,
      default: false,
    },
    isAllChecked: {
      type: Boolean,
      default: false,
    },
    selectAll: {
      type: Boolean,
      default: false,
    },
    filterButton: {
      type: Boolean,
      default: false,
    },
    isCheckbox: {
      type: Boolean,
      default: true,
    },
    filterButtonTitle: {
      type: String,
      default: "Apply",
    },
    selectedValue: {},
    disabled: {
      default: false,
    },
    isCustomeCheckbox: {
      default: false,
    },
    isCheckboxChecked: {
      default: false,
    },
    customeCheckboxTitle: {
      default: "",
    },
    itemDisabled: {
      default: false,
    }
  },
  watch: {
    selectedValue: function (newVal, oldVal) {
    },
    selectedItemsArr: function (newVal, oldVal) {
      this.checkedItems = newVal;
      if (this.options.length == this.checkedItems.length) {
        this.checkedAllBox = true;
      }
      
      this.changeTitle();
    },
    isAllChecked: function (newVal, oldVal) {
      this.checkedAllBox = newVal;
      this.changeTitle();
    },
  },
  mounted() {
    this.changeTitle();
    if (this.isAllChecked) {
      document
        .querySelectorAll(
          "input[type='checkbox'][name='custom-checkall-checkbox-" +
          this.selectTitle +
          "']"
        )
        .forEach((chk, index) => {
          this.checkedItems.push(chk.value);
        });
      this.selectedItems = this.options;
      this.filterApply();
    } else {
      this.checkedItems = this.selectedItemsArr;
    }
  },
  data() {
    return {
      downArrowIcon: new URL("/assets/images/icons/down-arrow.svg", import.meta.url).href,
      selectedItems: [],
      optionsList: [],
      checkedItems: this.selectedItemsArr,
      checkedAllBox: this.isAllChecked,
      searchItems: "",
      selectedItemTitle: "",
      isSearch: false,
    };
  },
  methods: {
    checkItemDisabled(id) {
      if (this.itemDisabled == true) {
        if (this.checkedItems.includes(id)) {
          return false;
        }else{
          return true;
        }
      }else{
        return false;
      }
    },
    searchItemFromList(e) {
      this.isSearch = false;
      this.optionsList = this.options;
      if (e != "") {
        this.isSearch = true;
        var search = new RegExp(e, "i"); // prepare a regex object
        const results = [];
        this.options.forEach((category) => {
          const resultsData = [];
          category.value.forEach((item) => {
            if (item.name.toLowerCase().includes(e.toLowerCase())) {
              resultsData.push(item);
            }
          });
          if (resultsData.length > 0) {
            results.push({ id: category.id, name: category.name, value: resultsData });
          }
        });
        this.optionsList = results;
      }
    },
    checkAll(event) {
      this.checkedItems = [];
      this.selectedItems = [];
      this.checkedAllBox = false;
      if (event) {
        document
          .querySelectorAll(
            "input[type='checkbox'][name='custom-checkall-checkbox-" +
            this.selectTitle +
            "']"
          )
          .forEach((chk, index) => {
            this.checkedItems.push(chk.value);
          });
        this.selectedItems = this.options;
        this.checkedAllBox = true;
      }
      this.changeTitle();
      if (this.filterButton == false) {
        let hide = false;
        this.filterApply();
      }
    },
    checkRow() {
      if (this.checkedItems.length == this.options.length) {
        this.checkedAllBox = true;
      } else {
        this.checkedAllBox = false;
      }
      this.changeTitle();
      this.filterApply();
    },
    changeTitle() {
      this.selectedItems = [];
      if (this.checkedItems.length > 0) {
        this.checkedItems.forEach((element) => {
          this.options.forEach((elem) => {
            if (elem.value.length > 0) {
              elem.value.forEach((opt) => {
                if (opt.id == element) {
                  this.selectedItems.push(opt);
                }
              });
            }
          });
        });
      }
      if (this.selectedItems.length > 0) {
        if (this.selectedItems.length > 1) {
          this.selectedItemTitle =
            this.selectedItems[0].name +
            " & " +
            (this.selectedItems.length - 1) +
            " More";
        } else {
          this.selectedItemTitle = this.selectedItems[0].name;
        }
      } else {
        this.selectedItemTitle = "";
      }
    },
    selectedValueText() {
      let title = this.selectedValue;
      this.options.forEach((opt, index) => {
        if (opt.id == this.selectedValue) {
          title = opt.name;
        }
      });
      return title;
    },
    filterApply(value = "", hide = false, searchClear = false) {
      if (searchClear == true) {
        this.searchItems = "";
        this.isSearch = false;
        this.optionsList = this.options;
      }

      if (this.isCheckbox) {
        let data = {
          selectedItems: this.selectedItems,
          checkedAllBox: this.checkedAllBox,
          checkboxName: this.checkboxName,
        };
        this.$emit("filterButtonAction", data);
      } else {
        this.$emit("filterButtonAction", value);
      }

      if (hide) {
        this.$refs.cDropdown.hide();
      }
      
      if(this.selectedItems.length == 3){
        this.$refs.cDropdown.hide();
      }
    },
    customAction(event) {
      this.$emit("customeCheckboxAction", event);
    },
  },
};
</script>
